from mmath.Vector3 import *

class Normal3(Vector3):
	
	def __sub__(self, other):
		return Normal3(self.x - other.x, self.y - other.y, self.z - other.z)
	
	def __add__(self, other):
		return Normal3(self.x + other.x, self.y + other.y, self.z + other.z)
	
	def __rmul__(self, other):
		if (type(other) == int or type(other) == float):
			return Normal3(self.x * other, self.y * other, self.z * other)
	
	def __mul__(self, other):
		"Dot product and scalar mult"
		if (type(other) == int or type(other) == float):
			return Normal3(self.x * other, self.y * other, self.z * other)
		elif type(other) in [Vector3, Normal3]:
			return self.x * other.x + self.y * other.y + self.z * other.z
	
	def __xor__(self, other):
		"Cross product, returns a vector3"
		if type(other) in [Vector3, Normal3]:
			return Vector3(
				self.y * other.z - self.z * other.y,
				self.z * other.x - self.x * other.z,
				self.x * other.y - self.y * other.x)
	
	def __neg__(self):
		return Normal3(- self.x, - self.y, - self.z)
	
	def angle(self, other):
		"returns the angle between two vectors, in radians"
		if type(other) in [Vector3, Normal3]:
			return math.acos((self * other) / (self.length() * other.length()))
	
	def __repr__(self):
		return 'geom.Normal3.Normal3(%s, %s, %s)' % (self.x, self.y, self.z)