#  Copyright (c) 2008 patrick coleman

import Point3
import BoundingBox

def centroid(pts):
	"returns the centroid of a list of points ("
	if len(pts) == 0: 
		return None
	c = Point3.Point3()
	for p in pts:
		c += p
	invDenom = 1.0 / len(pts)
	return invDenom * c

def colocated(pts, tol = 0.001):
	"""
		tests whether the points are the same win tol
	
		tol is a distance on the bounding box diagonal
	"""
	b = BoundingBox.BoundingBox(pts[0], pts[0])
	for i in range(1, len(pts)):
		b.addPoint(pts[i])
	return (b.diagonalSquared() <= tol * tol)

def colinear(pts, tol = 0.001):
	"""
		tests whether the pts are all colinear.  
		pts is a list of Point3's, length at least 3
		TOL is an internal tolerance un the cross product ot triplets.
		
		esentially tol is to the angle any point makes with the first 2
	"""
	# not working, finish when really needed
	return True
	
	tol2 = tol * tol
	
	v1 = None
	#for i in range(1, len
	
	if v1 is None:
		return True
	
	v1 = (pts[1] - pts[0]).normalize()
	
	for i in range(2, len(pts)):
		v2 = (pts[i] - pts[0]).normalize()
		if (v1 ^ v2).lengthSquared() > tol2:
			return False
	
	return True

def testColocated():
	# test true
	p1 = Point3.Point3(1, 2, 3)
	print colocated([p1, p1, p1])
		
	# test false
	p1 = Point3.Point3(1, 2, 3)
	p2 = Point3.Point3(1, 4, 6)
	print colocated([p1, p1, p2])
	
	# test false
	p3 = Point3.Point3(4, 8, 12)
	print colocated([p1, p2, p3])
	


def testColinear():
	
	# test true
	p1 = Point3.Point3(1, 2, 3)
	p2 = Point3.Point3(2, 4, 6)
	p3 = Point3.Point3(4, 8, 12)
	print colinear([p1, p2, p3])
	
	# test true (2 pts equal)
	print colinear([p1, p2, p2])
	
	# test true (all pts equal)
	print colinear([p1, p1, p1])
	
	#test false
	p4 = Point3.Point3(4, 8, 12.1)
	print colinear([p1, p2, p4])
	
	
	
if __name__ == '__main__':
	testColocated()
	#testColinear()