#  Copyright (c) 2008 patrick coleman

import mmaya
import mmaya.Node
from geom.Point3 import Point3
import maya.cmds as mc
from motion.EventExtractorVisualizer import RotationStreamlineVisualizer
import msignal.Histogram

class MayaRSV(RotationStreamlineVisualizer):
	def createStreamlineCurve(self, streamline, transform):
		crv = mmaya.makeCurve(streamline.points, transform + 'SL')
		mc.pointConstraint(transform, crv)
		parent = mmaya.Node.Node(transform).parent()
		if parent != None:
			mc.orientConstraint(parent.name, crv)
	
	def plotSignal(self, signal, name = 'signal', x0 = 0.0, y0 = 0.0, xStep = 0.1, yScale = 1.0, z = 0.0):
		pts = []
		for i in range(len(signal)):
			pts.append(Point3(x0 + i * xStep, y0 + yScale * signal[i], z))
		mmaya.makeCurve(pts, name)
	
	def plotHistogram(self, signal, name = 'histogram', bins = 50, 
		x0 = 0.0, y0 = 0.0, xStep = 0.1, yScale = 1.0, z = 0.0):
		
		h = msignal.Histogram.Histogram(signal, bins = bins)
		hist = h.output()
		
		self.plotSignal(hist, name, x0, y0, xStep, yScale, z)