import maya.cmds as mc

def writeVertexData(mesh, f):

	numVerts = len(mc.listAttr(mesh + '.vrts', m = True)) / 4
	for i in range(numVerts):
		v = mc.getAttr(mesh + '.vrts[' + str(i) + ']')[0]
		f.write('v ' + str(v[0]) + ' ' + str(v[1]) + ' ' + str(v[2]) + '\n')

def writeFaceData(mesh, f):
	numVerts = len(mc.listAttr(mesh + '.vrts', m = True)) / 4
	
	
	numFaces = len(mc.listAttr(mesh + '.face', m = True))
	for i in range(numFaces):
		faceDataStr = mc.polyInfo(mesh + '.f[' + str(i) + ']', fv = True)[0]
		faceData = faceDataStr.split()[2:]
		f.write('f')
		for j in range(len(faceData)):
			f.write(' ' + str(int(faceData[j]) + 1))
		f.write('\n')
		
def exportObj(mesh, fname = 'default'):
	# open file
	fname = '/Users/malarki/models/' + fname + '.obj'
	f = open(fname, 'w')
	
	# write data
	writeVertexData(mesh, f)
	writeFaceData(mesh, f)
		
	f.close()