#  Copyright (c) 2008 patrick coleman

from geom.Point3 import Point3
from mmaya.Streamline import SpaceEvaluator
from motion.Streamline import StreamlineCreator
import mmaya
import geom.Curve
import geom.SplineAnalysis
import maya.cmds as mc

class RBSplineFitter(object):

	def __init__(self, transform, smoothingBias = 0.5, smoothingIterations = 50):
		self.transform = transform
		self.smoothingBias = smoothingBias
		self.smoothingIterations = smoothingIterations
		pvtList = mc.xform(transform, q = True, rp = True)
		pvt = Point3(pvtList[0], pvtList[1], pvtList[2])
		eval = SpaceEvaluator(transform, pvt)
		sc = StreamlineCreator(mmaya.sceneStartTime(), mmaya.sceneEndTime(), eval)
		sl = sc.streamline()
		self.sampledSpline = geom.Curve.SampledSpline(sl.points, sl.times)
	
	def displacementHandleSpline(self): 
		dhsc = geom.SplineAnalysis.DisplacementHandleSplineCreator(self.sampledSpline,
																   self.smoothingBias,
																   self.smoothingIterations)
		return dhsc.spline()
																   
	
	def handleSpline(self):
		hsc = geom.SplineAnalysis.HandleSplineCreator(self.sampledSpline)
		return hsc.spline()
