#  Copyright (c) 2008 patrick coleman

import maya.cmds as mc

def ScaleSceneTime(multiplier = 1):
	allCurves = mc.ls(type = 'animCurve')

	for c in allCurves:
		numKeys = len(mc.listAttr(c + '.ktv', m = True)) / 3
		indices = range(numKeys)
		if multiplier > 1.0:
			indices.reverse() # counteract maya's dynamic sorting
		for i in indices:
			t = mc.getAttr(c + '.ktv[' + str(i) + '].kt')
			mc.keyframe(c, option = 'over', index = (i,i), absolute = True, timeChange = multiplier * t)