#  Copyright (c) 2008 patrick coleman

"Event Signal classes.  This is a Maya free module"

from Exceptions import *

class EventSignal(object):

	def __init__(self, name, startTime, endTime, attributes = []):
		self.name = name
		self.startTime = startTime
		self.endTime = endTime
		self.attributes = attributes
		self.events = dict([[attr, []] for attr in attributes])
		
	def attribute(self, name):
		return self.attributes[self.attributeIndex(name)]
	
	def attributeIndex(self, name):
		for i in range(len(self.attributes)):
			if self.attributes[i] == name:
				return i
		raise NonExistentAttribute()
		
	def appendAttribute(self, name):
		if name in self.attributes:
			raise PreExistingAttribute()
		self.attributes.append(name)
	
	def numEvents(self, attribute):
		return len(self.events[attribute])
	
	def event(self, attribute, i):
		return self.events[attribute][i]
	
	def clearEvents(self):
		self.events = dict([[attr, []] for attr in self.attributes])
	
	def setEvents(self, attribute, attrEvents):
		self.events[attribute] = attrEvents
		self.events[attribute].sort()
	
	def addEvent(self, attribute, event):
		self.events[attribute].append(event)
		self.events[attribute].sort()
		
		
