#  Copyright (c) 2008 patrick coleman

class Event(object):
	def __init__(self, time):
		self.time = time
	
	def __cmp__(self, other):
		if isinstance(other, Event):
			return cmp(self.time, other.time)
		else:
			return cmp(self.time, other)

class RotationExtremumEvent(Event):
	def __init__(self, time):
		Event.__init__(self, time)

# Used by RotationChangeExtractor

class RotationChangeEvent(Event):
	def __init__(self, time, startTime, endTime):
		Event.__init__(self, time)
		self.startTime = startTime
		self.endTime = endTime
		
	def duration(self):
		return (self.endTime - self.startTime)

# Used by RotationPoseExtractor

class DataBoundEvent(Event):
    pass

class DataStartEvent(DataBoundEvent):
    pass

class DataEndEvent(DataBoundEvent):
    pass

class ZeroSignalEvent(Event):
    pass

class ZeroStartEvent(ZeroSignalEvent):
    pass

class ZeroEndEvent(ZeroSignalEvent):
    pass
	
# Used by RotationStreamlineExtractor

class StreamlineExtremaEvent(Event):
	def __init__(self, time, magnitude):
		"takes a time and magnitude.  the latter can be something like curvature"
		Event.__init__(self, time)
		self.magnitude = magnitude

class StreamlineExtremaEvent(Event):
	def __init__(self, time, magnitude):
		"takes a time and magnitude.  the latter can be something like curvature"
		Event.__init__(self, time)
		self.magnitude = magnitude	

# Streamframe Events

class StreamframeExtremaEvent(Event):
	def __init__(self, index, time, magnitude, component):
		"takes a time and magnitude.  the latter can be something like curvature"
		Event.__init__(self, time)
		self.index = index
		self.magnitude = magnitude	
		self.component = component