#  Copyright (c) 2008 patrick coleman

from Exceptions import *

class StreamframeSetCreator(object):
	def __init__(self, motion, attribute):
		"motion and attribute specify what to create the streamframes from" 
		self.motion = motion
		self.attribute = attribute
	
	def streamframes(self):
		"Returns a list of streamframes"
		raise AbstractMethod()

class StreamframeDictionaryCreator(object):
	def __init__(self, motion, setCreatorClass, setCreatorClassArgs):
		self.motion = motion
		self.setCreatorClass = setCreatorClass
		self.setCreatorClassArgs = setCreatorClassArgs
	
	def streamframeDictionary(self):
		dict = {}
		for attr in self.motion.attributes:
			if attr.split('.')[1] == 'rotate':
				pArgs = (self.motion, attr)
				setCreator = apply(self.setCreatorClass, pArgs, self.setCreatorClassArgs)
				dict[attr] = setCreator.streamframes()
		return dict