#  Copyright (c) 2008 patrick coleman

import Streamline

class Streamribbon(Streamline.Streamline):
	def __init__(self, points = [], ribbonPoints = [], times = []):
		Streamline.Streamline.__init__(self, points, times)
		self.ribbonPoints = ribbonPoints
	
	def addPoint(self, time, point, ribbonPoint):
		Streamline.Streamline.addPoint(self, time, point)
		self.ribbonPoints.append(ribbonPoint)
	
	def clear(self):
		Streamline.Streamline.clear(self)
		self.ribbonPoints = []

class StreamribbonCreator(object):
	def __init__(self, startTime, endTime, evaluator, ribbonEvaluator, step = 1):
		self.startTime = startTime
		self.endTime = endTime
		self.evaluator = evaluator
		self.ribbonEvaluator = ribbonEvaluator
		self.step = step
	
	def streamribbon(self):
		s = Streamribbon()
		s.clear()
		
		t = self.startTime
		while t <= self.endTime:
			s.addPoint(t, self.evaluator.position(t), self.ribbonEvaluator.position(t))
			t += self.step

		return s

def _testEval():
	class TestEval(Streamline.Evaluator):
		def position(self, time):
			return time * time
	class TestEval2(Streamline.Evaluator):
		def position(self, time):
			return time * time * time
	sc = StreamribbonCreator(1, 25, TestEval(), TestEval2())
	sl = sc.streamribbon()
	print [t for t in sl.times]
	print [p for p in sl.points]
	print [p for p in sl.ribbonPoints]
	
if __name__ == '__main__':
	_testEval()