#  Copyright (c) 2008 patrick coleman

class Histogram(object):
	def __init__(self, signal, bins = 50, minValue = None, maxValue = None):
		self.signal = signal
		self.bins = bins
		self.minValue = minValue
		self.maxValue = maxValue
		if minValue == None:
			self.minValue = min(signal)
		if maxValue == None:
			self.maxValue = max(signal)
		if self.maxValue <= self.minValue:
			self.maxValue = self.minValue + 1.0
		self.binWidth = float(self.maxValue - self.minValue) / bins
		self.invBinWidth = 1.0 / self.binWidth
	
	def _bin(self, value):
		"determines what bin a value belongs in"
		bin = int((value - self.minValue) * self.invBinWidth)
		if bin < 0:
			bin = 0
		if bin >= self.bins:
			bin = self.bins - 1
		return bin
	
	def output(self):
		hist = []
		for i in range(self.bins):
			hist.append(0)
		for v in self.signal:
			hist[self._bin(v)] += 1
		return hist