#  Copyright (c) 2008 patrick coleman

class StatisticEvaluator(object):
	def __init__(self, data):
		self.data = data
		self.sortedData = None
	
	def mean(self):
		sumValue = sum(self.data)
		return float(sumValue) / len(self.data)
	
	def percentileValue(self, percentile):
		self._verifySorted()
		
		index = int(percentile * len(self.sortedData))
		if index < 0:
			index = 0
		if index >= len(self.sortedData):
			index = len(self.sortedData) - 1
		return self.sortedData[index]
	
	def _verifySorted(self):
		if self.sortedData == None:
			self.sortedData = self.data[:]
			self.sortedData.sort()